poj3417 LCA + 树形dp

Network

Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 4478   Accepted: 1292

Description

Yixght is a manager of the company called SzqNetwork(SN). Now she‘s very worried because she has just received a bad news which denotes that DxtNetwork(DN), the SN‘s business rival, intents to attack the network of SN. More unfortunately, the original network of SN is so weak that we can just treat it as a tree. Formally, there are N nodes in SN‘s network, N-1 bidirectional channels to connect the nodes, and there always exists a route from any node to another. In order to protect the network from the attack, Yixght builds M new bidirectional channels between some of the nodes.

As the DN‘s best hacker, you can exactly destory two channels, one in the original network and the other among the M new channels. Now your higher-up wants to know how many ways you can divide the network of SN into at least two parts.

Input

The first line of the input file contains two integers: N (1 ≤ N ≤ 100 000), M (1 ≤ M ≤ 100 000) — the number of the nodes and the number of the new channels.

Following N-1 lines represent the channels in the original network of SN, each pair (a,b) denote that there is a channel between node a and node b.

Following M lines represent the new channels in the network, each pair (a,b) denote that a new channel between node a and node b is added to the network of SN.

Output

Output a single integer — the number of ways to divide the network into at least two parts.

Sample Input

4 1
1 2
2 3
1 4
3 4

Sample Output

3

题意:

有n个点的树,另外添加m - 1条边。现在要你删除一条树上原有的边,和一条添加的边,使图分成2部分,有多少种方法。

思路:

在树上添加边之后,一定会构成一个环,那么对于当前的这个环,就是删除这条添加的边和原有的边后,可以分成2部分。所以题目可以转化为每天边被环包围了几次。

如果只有0次,说明这条树边删除后,直接分成了2部分,方案书就是m种。如果当前被被包围1次,那么说明这个环中方案树为环中树边的个数。包围次数大于1的,

方案为0,因为至少删除2条添加的边和1条树边后才能分成2部分。

对于添加的边x,y,我们可以找到lca(x,y),然后用点表示边,s[x] += 1,s[y] += 1,表示x和y所在的边被包围了一次,对于x->lca(x,y)和y->lca(x,y)上的边可以用树形dp来处理,

由于这里用点表示边,lca(x,y)这个点肯定被加了2次,由于lca(x,y)代表的边不在这个环中,所以s[lca(x,y)] -= 2; 剩下的就是判断一下答案即可。

/*
 * Author:  sweat123
 * Created Time:  2016/7/14 8:29:55
 * File Name: main.cpp
 */
#include<set>
#include<map>
#include<queue>
#include<stack>
#include<cmath>
#include<string>
#include<vector>
#include<cstdio>
#include<time.h>
#include<cstring>
#include<iostream>
#include<algorithm>
#define INF 1<<30
#define MOD 1000000007
#define ll long long
#define lson l,m,rt<<1
#define key_value ch[ch[root][1]][0]
#define rson m+1,r,rt<<1|1
#define pi acos(-1.0)
using namespace std;
const int MAXN = 100010;
struct node{
    int to;
    int next;
}edge[MAXN*2];
int pre[MAXN],ind,vis[MAXN],dfn[MAXN*2],dp[MAXN*2][20],rev[MAXN*2],tot,first[MAXN],n,m;
int s[MAXN];
void add(int x,int y){
    edge[ind].to = y;
    edge[ind].next = pre[x];
    pre[x] = ind ++;
}
void dfs(int rt,int dep){
    vis[rt] = 1;
    rev[++tot] = rt;
    first[rt] = tot;
    dfn[tot] = dep;
    for(int i = pre[rt]; i != -1; i = edge[i].next){
        int t = edge[i].to;
        if(!vis[t]){
            dfs(t,dep+1);
            rev[++tot] = rt;
            dfn[tot] = dep;
        }
    }
}
void rmq(){
    for(int i = 1; i <= tot; i++){
        dp[i][0] = i;
    }
    for(int i = 1; i < 20; i++){
        for(int j = 1; j + (1 << i) - 1 <= tot; j++){
            int l = dp[j][i-1];
            int r = dp[j+(1<<(i-1))][i-1];
            if(dfn[l] > dfn[r]){
                dp[j][i] = r;
            } else{
                dp[j][i] = l;
            }
        }
    }
}
int lca(int x,int y){
    x = first[x];
    y = first[y];
    if(x > y)swap(x,y);
    int k = (int)(log(y - x + 1) * 1.0 / log(2.0));
    int l = dp[x][k];
    int r = dp[y - (1 << k) + 1][k];
    if(dfn[l] > dfn[r])return r;
    return l;
}
void tree_dfs(int rt){
    vis[rt] = 1;
    for(int i = pre[rt]; i != -1; i = edge[i].next){
        int t = edge[i].to;
        if(!vis[t]){
            tree_dfs(t);
            s[rt] += s[t];
        }
    }
}
void init(){
    ind = tot = 0;
    memset(pre,-1,sizeof(pre));
    memset(s,0,sizeof(s));
}
int main(){
    while(~scanf("%d%d",&n,&m)){
        init();
        for(int i = 1; i < n; i++){
            int x,y;
            scanf("%d%d",&x,&y);
            add(x,y);
            add(y,x);
        }
        memset(vis,0,sizeof(vis));
        dfs(1,1);
        rmq();
        for(int i = 1; i <= m; i++){
            int x,y;
            scanf("%d%d",&x,&y);
            int tp = rev[lca(x,y)];
            s[x] ++;
            s[y] ++;
            s[tp] -= 2;// the ponint of lca(x,y) has no birdge and I hava count two way
        }
        memset(vis,0,sizeof(vis));
        tree_dfs(1);
        ll ans = 0;
        for(int i = 2; i <= n; i++){
            if(s[i] <= 0){
                ans += m;
            } else if(s[i] == 1){
                ans += 1;
            }
        }
        printf("%lld\n",ans);
    }
    return 0;
}
时间: 2024-11-05 11:00:55

poj3417 LCA + 树形dp的相关文章

HDU 4008 Parent and son LCA+树形dp

题意: 给定case数 给定n个点的树,m个询问 下面n-1行给出树边 m个询问 x y 问:以x为根,y子树下 y的最小点标的儿子节点 和子孙节点 思路: 用son[u][0] 表示u的最小儿子 son[u][2] 表示u的次小儿子 son[u][1] 表示u的最小子孙 若lca(x,y)  !=y  则就是上述的答案 若lca(x,y) == y 1.y != 1 那么最小儿子就是除了x外的节点,且此时father[y] 也是y的儿子节点, 而最小的子孙节点就是1 2.y==1 那么特殊处理

[poj3417]Network(LCA+树形dp)

题意:给出一棵无根树,然后下面再给出m条边,把这m条边连上,每次你去两条边,规定一条是树边,一条是新边,问有多少种方案能使树断裂. 解题关键:边权转化为点权,记录每条边被环覆盖的次数,通过val[a]++,val[b]++,val[lca(a,b)]-=2,来控制每个点上面的边,所以树的顶点要去掉. 好久没1A了,开心 1 //#pragma comment(linker, "/STACK:1024000000,1024000000") 2 #include<cstdio>

HDOJ 5293 Tree chain problem LCA+树链剖分+树形DP

[题意] 给定一颗树上的几条链和每条链的权值,求能取出的不含有公共节点的链的最大权值.... [解] 预处理每条链的lca 树形DP, d[i]表示取到这个节点时可以得到的最大值 , sum[i]=sigma( d[k] | k 是i的子节点) 如果不取i  d[i]=sum[i] 如果取i , e是lca为i的链则 d[i]=max(d[i],e的权值+sigma(sum[k])-sigma(d[k]))  k为树链上的点 可以用树链剖分+树装数组在nlogn的时间复杂度内求链上的值 Tree

Codeforces 418d Big Problems for Organizers [树形dp][倍增lca]

题意: 给你一棵有n个节点的树,树的边权都是1. 有m次询问,每次询问输出树上所有节点离其较近结点距离的最大值. 思路: 1.首先是按照常规树形dp的思路维护一个子树节点中距离该点的最大值son_dis[i],维护非子树节点中距离该点的最大值fa_dis[i]; 2.对于每个节点维护它最大的三个儿子节点的son_dis; 3.维护up[i][j]和down[i][j]数组,这个类似倍增lca里边的fa[i][j],up[i][j]代表的含义是从第j个点向上到它的第2^i个父节点这条链上的点除了该

【bzoj3362/3363/3364/3365】[Usaco2004 Feb]树上问题杂烩 并查集/树形dp/LCA/树的点分治

题目描述 农夫约翰有N(2≤N≤40000)个农场,标号1到N,M(2≤M≤40000)条的不同的垂直或水平的道路连结着农场,道路的长度不超过1000.这些农场的分布就像下面的地图一样, 图中农场用F1..F7表示, 每个农场最多能在东西南北四个方向连结4个不同的农场.此外,农场只处在道路的两端.道路不会交叉且每对农场间有且仅有一条路径.邻居鲍伯要约翰来导航,但约翰丢了农场的地图,他只得从电脑的备份中修复了.每一条道路的信息如下: 从农场23往南经距离10到达农场17 从农场1往东经距离7到达农

HDU 5293 Tree chain problem 树形dp+dfs序+树状数组+LCA

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=5293 题意: 给你一些链,每条链都有自己的价值,求不相交不重合的链能够组成的最大价值. 题解: 树形dp, 对于每条链u,v,w,我们只在lca(u,v)的顶点上处理它 让dp[i]表示以i为根的指数的最大值,sum[i]表示dp[vi]的和(vi为i的儿子们) 则i点有两种决策,一种是不选以i为lca的链,则dp[i]=sum[i]. 另一种是选一条以i为lca的链,那么有转移方程:dp[i]=

【BZOJ2286】【SDOI2011】消耗战 LCA单调性(构建虚树)+树形DP

题解: 首先我们考虑每次都做一遍树形DP(树形DP自己脑补去,随便乱搞就过了). 显然这是TLE无疑的. 所以可以利用LCA单调性构建虚树. 思想: 我们发现每次树形DP有很多点用不到,但是却需要被扫过,让他们见鬼去吧! 实现: 我们只对每次扫的图插入本次询问需要的节点,以及它们的LCA. 这样询问了m个点,虚树就至多只需要2m个点(so quick). 而插入顺序上不妨利用LCA单调性来把点按dfs度排个序,然后挨个插入单调栈. 同时我们要保证单调栈维护的是一条链,也就是一旦不是链了,我们自然

poj3417(LCA+DP)

题目连接:http://poj.org/problem?id=3417 tarjan+树DP 来自:http://www.cnblogs.com/scau20110726/archive/2013/05/31/3110666.html 1 #include<cstdio> 2 #include<cstring> 3 #include<algorithm> 4 #include<cmath> 5 using namespace std; 6 const int

代码风格与树形DP

Streaming很惨,不过因为比赛之间没有提交过就没掉(或掉了)rating.第二题是一个树形DP,但是我都在想第一题了,简直作死. 看着神犇的代码我也是醉了...各种宏,真是好好写会死系列. 看到他们Tree DP都用的DFS,突然感觉我这个蒟蒻的生活中充满了无力... 我一般都喜欢用BFS进行Tree DP.这样坏处很多,难调试,容易爆空间等.好处也有,写起来快,代码短,跑得飞快,判重简单.不过这样做是有条件的,而今天的Streaming这题就是一道可以的题. 然后讲讲今天这道LCASta